# Goal

This repository contains the scripts and files necessary to create the two major tabular datasets, `modeldata` and `assmntdata`, that are used to [calculate assessed values for all Cook County residential property](https://gitlab.com/ccao-data-science---modeling/models/ccao_res_avm)<sup>1</sup>. It also creates one ancillary dataset, `hiedata`. This repository does *not* contain any modeling code, it only prepares the data used in modeling and prediction.

* `modeldata` is the set of sales used to train the machine learning model that generates assessed values. Each row represents a residential sale with corresponding property characteristics, geographic attributes, metadata, and sale information. Properties may appear multiple times in this data set if they have multiple sales within the time range specified in the script (usually 7 years). Characteristics in this dataset have been updated to reflect 288 changes, see [here](https://ccao-data-science---modeling.gitlab.io/packages/ccao/reference/chars_sparsify.html) for more information.

* `assmntdata` is the set of all properties which need to be assessed. Each row represents one property (or one improvement, in the case of multi-codes), and contains the same property information as `modeldata`. Characteristics for each property are taken from the year prior to assessment (e.g. a 2021 reassessment will use 2020 characteristics). Characteristics in this dataset do *not* reflect 288s.

# Inputs

Nearly all of the data used for residential modeling is stored in the CCAO's on-prem SQL database. This data is updated on a regular basis from the County mainframe using the CCAO's AS/400 system. The primary data sources include:

* **VW_RES_UNIVERSE** - A SQL view which combines tables with the goal of retrieving a set of characteristics for each PIN, year, and multi-code.
* **VW_PINGEO** - Geographic location and information for each PIN, including appended data such as census tract median income, ward, tax information, etc.
* **VW_CLEAN_IDORSALES** - Sale information and records from the Illinois Department of Revenue, including sale price and deed type.
* **ADDCHARS** - Properties which receive a Home Improvement Exemption have their characteristics stored in a separate table called ADDCHARS. These characteristics must be included when training a model in order to accurately reflect sale price. See [ccao::chars_288_active()](https://ccao-data-science---modeling.gitlab.io/packages/ccao/reference/chars_288_active.html) for more information.


# Outputs

The following files are created by this repository within the `output/` subfolder:

* `modeldata.parquet` - Tabular dataset containing properties used to train the assessment model, see above.
* `assmntdata.parquet` - Tabular dataset containing properties to be assessed, see above.
* `data_report.html` - HTML report generated by `scripts/create_report.Rmd`. Contains information on data quality and warnings about any potential issues.

These outputs are transferred as-is to the `inputs/` subfolder of the [residential CAMA repository](https://gitlab.com/ccao-data-science---modeling/models/ccao_res_avm), where they are used to train a machine learning model and subsequently predict assessed values.

---

<sup>1</sup> Residential properties include all 200-class properties except 200, 201, 241 (land and garages) and 299/399 (residential condominiums).


